classification
Title: formatwarning function signature change breaks code
Type: behavior Stage: test needed
Components: Interpreter Core Versions: Python 2.6
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: Nosy List: georg.brandl, v+python
Priority: normal Keywords:

Created on 2009-01-09 11:08 by v+python, last changed 2010-08-01 07:39 by georg.brandl. This issue is now closed.

Messages (3)
msg79462 - (view) Author: Glenn Linderman (v+python) * Date: 2009-01-09 11:08
External code that temporarily replaces warnings.formatwarning, a
technique used in IDLE and worked around (see issue 4043), is broken by
the addition of the optional parameter lineno to the formatwarning function.

While normal calls to functions can be "compatibly" extended with
additional optional parameters, that is not the case when the function
is substituted for, by matching its signature... if the signature is
extended, the code breaks on a Python upgrade, because the substituted
function doesn't know about the new parameter, and has fewer than are
being supplied by calls to the function.

Whether this is good, bad, documented, or appropriate, I don't know, but
it broke CherryPy 3.1.1 when running on Python 2.6, because of the new,
optional, lineno=None parameter to warnings.formatwarning



Not sure I have type and components right.  I'm a newbie.

This problem probably also applies to 3.0, but I don't have the
environment to test it there at present.

I first described this problem on python-dev and the suggestion was made
to put it here (remainder of this comment is a quote):

This formatwarning compatibility problem between 2.5 and 2.6 is a bug.
Please file a new issue for this.

-- Amaury Forgeot d'Arc
msg79463 - (view) Author: Glenn Linderman (v+python) * Date: 2009-01-09 11:13
For reference, the issue on the CherryPy tracker is #891 (amazing
numerical coincidence 891 there and 4891 here).
msg112275 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2010-08-01 07:39
Probably too late to change something here.
History
Date User Action Args
2010-08-01 07:39:58georg.brandlsetstatus: open -> closed

nosy: + georg.brandl
messages: + msg112275

resolution: out of date
2010-02-09 16:40:20brian.curtinsetpriority: normal
type: crash -> behavior
stage: test needed
2009-01-09 11:13:58v+pythonsetmessages: + msg79463
2009-01-09 11:08:59v+pythoncreate